Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class JTable

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JTable

public class JTable
extends JComponent
implements TableModelListener, Scrollable, TableColumnModelListener, ListSelectionListener, CellEditorListener, Accessible

JTable is a user-interface component that presents data in a two-dimensional table format. The JTable has many facilities that make it possible to customize its rendering and editing but provides defaults for these features so that simple tables can be set up easily. For example, to set up a table with 10 rows and 10 columns of numbers:

          TableModel dataModel = new AbstractTableModel() {
              public int getColumnCount() { return 10; }
              public int getRowCount() { return 10;}
              public Object getValueAt(int row, int col) { return new Integer(row*col); }
          };
          JTable table = new JTable(dataModel);
          JScrollPane scrollpane = new JScrollPane(table);

Because the JTable is now much easier to set up with custom models the DefaultTableModel is less useful than it was in previous releases. Instead of copying the data in an application into the DefaultTableModel, we recommend wrapping it in the methods of the TableModel interface and passing the real data to the JTable as above. This technique is nearly as concise as using a DefaultTableModel and starting this way has a number of advantages over the longer term. In particular: it is a scalable technique, is easier to handle dynamic or editable tables and often results in much more efficient applications because the model is free to choose the internal representation that best suits the data.

The "Table" directory in the examples/demo area gives a number of complete examples of JTable usage, covering how the JTable can be used to provide an editable view of data taken from a database and how to modify the columns in the display to use specialized renderers and editors. For example, overriding AbstractTableModel's `getColumnClass()` method to return a value of `ImageIcon.class` for a given column allows icons to be displayed, while returning a value of `Number.class` allows digits to be right-justified in the column.

The JTable uses integers exclusively to refer to both the rows and the columns of the model that it displays. The JTable simply takes a tabular range of cells and uses `getValueAt(int, int)` to retrieve and display the appropriate values from the model.

If `getTableHeader().setReorderingAllowed(boolean)` is used to enable column reordering columns may be rearranged in the JTable so that the view's columns appear in a different order to the columns in the model. This does not affect the implementation of the model at all: when the columns are reordered, the JTable maintains the new order of the columns internally and converts its column indices before querying the model.

So, when writing a TableModel, it is not necessary to listen for column reordering events as the the model will be queried in its own co-ordinate system regardless of what is happening in the view. In the examples area there is a demonstration of a sorting algorithm making use of exactly this technique to interpose yet another co-ordinate system where the order of the rows is changed, rather than the order of the columns.

The general rule for the JTable API and the APIs of all its associated classes, including the the column model and both the row and column selection models, is: methods using integer indices for rows and columns always use the co-ordinate system of the view. There are three exceptions to this rule:

- All references to rows and columns in the TableModel interface are in the co-ordinate system of the model.
- The index modelIndex in the TableColumn constructors refers to the index of the column in the model, not the view.
- All constructors for the TableModelEvent, which describes changes that have taken place in a table model, use the co-ordinate system of the model.

The TableColumn provides a slot for holding an identifier or "tag" for each column and the JTable and TableColumModel both support getColumn(Object id) conveniences for locating columns by their identifier. If no identifier is explicitly set, the TableColumn returns its header value (the name of the column) as a default. A different identifier, which can be of any type, can be set using the TableColumn's setIdentifier() method. All of the JTable's functions operate correctly regardless of the type and uniqueness of these identifiers.

The convertColumnIndexToView() and convertColumnIndexToModel() methods have been provided to convert between the two co-ordinate systems but they are rarely needed during normal use.

Like all JComponent classes, you can use `JComponent.registerKeyboardAction(java.awt.event.ActionListener, java.lang.String, javax.swing.KeyStroke, int)` to associate an `Action` object with a `KeyStroke` and execute the action under specified conditions.

See How to Use Tables in The Java Tutorial for further documentation.

For the keyboard keys used by this component in the standard Look and Feel (L&F) renditions, see the JTable key assignments.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  Serialized Form

Inner Class Summary
`protected class` | `JTable.AccessibleJTable` The class used to obtain the accessible role for this object.

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Field Summary
`static int` | `AUTO_RESIZE_ALL_COLUMNS` During all resize operations, proportionately resize all columns
`static int` | `AUTO_RESIZE_LAST_COLUMN` During all resize operations, apply adjustments to the last column only
`static int` | `AUTO_RESIZE_NEXT_COLUMN` When a column is adjusted in the UI, adjust the next column the opposite way
`static int` | `AUTO_RESIZE_OFF` Do not adjust column widths automatically, use a scrollbar
`static int` | `AUTO_RESIZE_SUBSEQUENT_COLUMNS` During UI adjustment, change subsequent columns to preserve the total width
`protected boolean` | `autoCreateColumnsFromModel` The table will query the TableModel to build the default set of columns if this is true.
`protected int` | `autoResizeMode` This mode value determines if table automatically resizes the width the table's columns to take up the entire width of the table, and how it does the resizing.
`protected TableCellEditor` | `cellEditor` The object that overwrites the screen real estate occupied by the current cell and allows the user to change those contents.
`protected boolean` | `cellSelectionEnabled` If this is true, then both a row selection and a column selection can be non-empty at the same time, the selected cells are the the cells whose row and column are both selected.
`protected TableColumnModel` | `columnModel` The TableColumnModel of the table
`protected TableModel` | `dataModel` The TableModel of the table
`protected java.util.Hashtable` | `defaultEditorsByColumnClass` A table of objects that display and edit the contents of a cell, indexed by class.
`protected java.util.Hashtable` | `defaultRenderersByColumnClass` A table of objects that display the contents of a cell, indexed by class.
`protected int` | `editingColumn` Identifies the column of the cell being edited.
`protected int` | `editingRow` Identifies the row of the cell being edited.
`protected java.awt.Component` | `editorComp` If editing, Component that is handling the editing.
`protected java.awt.Color` | `gridColor` The color of the grid
`protected java.awt.Dimension` | `preferredViewportSize` Used by the Scrollable interface to determine the initial visible area
`protected int` | `rowHeight` The height of all rows in the table
`protected int` | `rowMargin` The height margin between rows
`protected boolean` | `rowSelectionAllowed` Row selection allowed in this table
`protected java.awt.Color` | `selectionBackground` The background color of selected cells
`protected java.awt.Color` | `selectionForeground` The foreground color of selected cells
`protected ListSelectionModel` | `selectionModel` The ListSelectionModel of the table, used to keep track of row selections
`protected boolean` | `showHorizontalLines` The table draws horizontal lines between cells if showHorizontalLines is true
`protected boolean` | `showVerticalLines` The table draws vertical lines between cells if showVerticalLines is true
`protected JTableHeader` | `tableHeader` The TableHeader working with the table

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Constructor Summary
`JTable()` Constructs a default JTable which is initialized with a default data model, a default column model, and a default selection model.
`JTable(int numRows, int numColumns)` Constructs a JTable with numRows and numColumns of empty cells using the DefaultTableModel.
`JTable(java.lang.Object[][] rowData, java.lang.Object[] columnNames)` Constructs a JTable to display the values in the two dimensional array, rowData, with column names, columnNames.
`JTable(TableModel dm)` Constructs a JTable which is initialized with dm as the data model, a default column model, and a default selection model.
`JTable(TableModel dm, TableColumnModel cm)` Constructs a JTable which is initialized with dm as the data model, cm as the column model, and a default selection model.
`JTable(TableModel dm, TableColumnModel cm, ListSelectionModel sm)` Constructs a JTable which is initialized with dm as the data model, cm as the column model, and sm as the selection model.
`JTable(java.util.Vector rowData, java.util.Vector columnNames)` Constructs a JTable to display the values in the Vector of Vectors, rowData, with column names, columnNames.

Method Summary
`void` | `addColumn(TableColumn aColumn)` Appends aColumn to the end of the array of columns held by the JTable's column model.
`void` | `addColumnSelectionInterval(int index0, int index1)` Adds the columns from index0 to index0 inclusive to the current selection.
`void` | `addNotify()` Calls `configureEnclosingScrollPane`.
`void` | `addRowSelectionInterval(int index0, int index1)` Adds the rows from index0 to index0 inclusive to the current selection.
`void` | `clearSelection()` Deselects all selected columns and rows.
`void` | `columnAdded(TableColumnModelEvent e)` Tells listeners that a column was added to the model.
`int` | `columnAtPoint(java.awt.Point point)` Returns the index of the column that point lies in, or -1 if it lies outside the receiver's bounds.
`void` | `columnMarginChanged(ChangeEvent e)` Tells listeners that a column was moved due to a margin change.
`void` | `columnMoved(TableColumnModelEvent e)` Tells listeners that a column was repositioned.
`void` | `columnRemoved(TableColumnModelEvent e)` Tells listeners that a column was removed from the model.
`void` | `columnSelectionChanged(ListSelectionEvent e)` Tells listeners that the selection model of the TableColumnModel changed.
`protected void` | `configureEnclosingScrollPane()` If the JTable is the viewportView of an enclosing JScrollPane (the usual situation), configure this ScrollPane by, amongst other things, installing the table's tableHeader as the columnHeaderView of the scrollpane.
`int` | `convertColumnIndexToModel(int viewColumnIndex)` Return the index of the column in the model whose data is being displayed in the column viewColumnIndex in the display.
`int` | `convertColumnIndexToView(int modelColumnIndex)` Return the index of the column in the view which is displaying the data from the column modelColumnIndex in the model.
`protected TableColumnModel` | `createDefaultColumnModel()` Returns the default column model object which is a DefaultTableColumnModel.
`void` | `createDefaultColumnsFromModel()` This method will create default columns for the table from the data model using the getColumnCount() and getColumnClass() methods defined in the TableModel interface.
`protected TableModel` | `createDefaultDataModel()` Returns the default table model object which is a DefaultTableModel.
`protected void` | `createDefaultEditors()` Creates default cell editors for Objects, numbers, and boolean values.
`protected void` | `createDefaultRenderers()`
`protected ListSelectionModel` | `createDefaultSelectionModel()` Returns the default selection model object which is a DefaultListSelectionModel.
`protected JTableHeader` | `createDefaultTableHeader()` Returns the default table header object which is a JTableHeader.
`static JScrollPane` | `createScrollPaneForTable(JTable aTable)` Deprecated. As of Swing version 1.0.2, replaced by `new JScrollPane(aTable)`.
`boolean` | `editCellAt(int row, int column)` Programmatically starts editing the cell at row and column, if the cell is editable.
`boolean` | `editCellAt(int row, int column, java.util.EventObject e)` Programmatically starts editing the cell at row and column, if the cell is editable.
`void` | `editingCanceled(ChangeEvent e)` Invoked when editing is canceled.
`void` | `editingStopped(ChangeEvent e)` Invoked when editing is finished.
`AccessibleContext` | `getAccessibleContext()` Get the AccessibleContext associated with this JComponent
`boolean` | `getAutoCreateColumnsFromModel()` Returns whether the table will create default columns from the model.
`int` | `getAutoResizeMode()` Returns auto resize mode of the table.
`TableCellEditor` | `getCellEditor()` Return the cellEditor.
`TableCellEditor` | `getCellEditor(int row, int column)` Return an appropriate editor for the cell specified by this this row and column.
`java.awt.Rectangle` | `getCellRect(int row, int column, boolean includeSpacing)` Returns a rectangle locating the cell that lies at the intersection of row and column.
`TableCellRenderer` | `getCellRenderer(int row, int column)` Return an appropriate renderer for the cell specified by this this row and column.
`boolean` | `getCellSelectionEnabled()` Returns true if simultaneous row and column selections are allowed
`TableColumn` | `getColumn(java.lang.Object identifier)` Returns the TableColumn object for the column in the table whose identifier is equal to identifier, when compared using equals().
`java.lang.Class` | `getColumnClass(int column)` Returns the type of the column at the specified view position.
`int` | `getColumnCount()` Returns the number of columns in the column model, note this may be different to the number of columns in the table model.
`TableColumnModel` | `getColumnModel()` Returns the TableColumnModel that contains all column inforamtion of this table.
`java.lang.String` | `getColumnName(int column)` Returns the name of the column at the specified view position.
`boolean` | `getColumnSelectionAllowed()` Returns true if columns can be selected.
`TableCellEditor` | `getDefaultEditor(java.lang.Class columnClass)` Returns the editor to be used when no editor has been set in a TableColumn.
`TableCellRenderer` | `getDefaultRenderer(java.lang.Class columnClass)` Returns the renderer to be used when no renderer has been set in a TableColumn.
`int` | `getEditingColumn()` This returns the index of the editing column.
`int` | `getEditingRow()` Returns the index of the editing row.
`java.awt.Component` | `getEditorComponent()` If the receiver is currently editing this will return the Component that was returned from the CellEditor.
`java.awt.Color` | `getGridColor()` Returns the color used to draw grid lines.
`java.awt.Dimension` | `getIntercellSpacing()` Returns the horizontal and vertical spacing between cells.
`TableModel` | `getModel()` Returns the TableModel that provides the data displayed by the receiver.
`java.awt.Dimension` | `getPreferredScrollableViewportSize()` Returns the preferred size of the viewport for this table.
`int` | `getRowCount()` Returns the number of rows in the table.
`int` | `getRowHeight()` Returns the height of a table row in the receiver.
`int` | `getRowMargin()` Gets the amount of emtpy space between rows.
`boolean` | `getRowSelectionAllowed()` Returns true if rows can be selected.
`int` | `getScrollableBlockIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)` Returns The visibleRect.height or visibleRect.width, depending on the table's orientation.
`boolean` | `getScrollableTracksViewportHeight()` Returns false to indicate that the height of the viewport does not determine the height of the table.
`boolean` | `getScrollableTracksViewportWidth()` Returns false to indicate that the width of the viewport does not determine the width of the table.
`int` | `getScrollableUnitIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)` Returns the scroll increment that completely exposes one new row or column (depending on the orientation).
`int` | `getSelectedColumn()` Returns the index of the last column selected or added to the selection.
`int` | `getSelectedColumnCount()` Returns the number of selected columns.
`int[]` | `getSelectedColumns()` Returns the indices of all selected columns.
`int` | `getSelectedRow()` Returns the index of the last row selected or added to the selection.
`int` | `getSelectedRowCount()` Returns the number of selected rows.
`int[]` | `getSelectedRows()` Returns the indices of all selected rows.
`java.awt.Color` | `getSelectionBackground()` Returns the background color for selected cells.
`java.awt.Color` | `getSelectionForeground()` Returns the foreground color for selected cells.
`ListSelectionModel` | `getSelectionModel()` Returns the ListSelectionModel that is used to maintain row selection state.
`boolean` | `getShowHorizontalLines()` Returns true if the receiver draws horizontal lines between cells, false if it doesn't.
`boolean` | `getShowVerticalLines()` Returns true if the receiver draws vertical lines between cells, false if it doesn't.
`JTableHeader` | `getTableHeader()` Returns the tableHeader working with this JTable.
`java.lang.String` | `getToolTipText(java.awt.event.MouseEvent event)` Overrides JComponent's setToolTipText method to allow use of the renderer's tips (if the renderer has text set).
`TableUI` | `getUI()` Returns the L&F object that renders this component.
`java.lang.String` | `getUIClassID()` Returns the name of the L&F class that renders this component.
`java.lang.Object` | `getValueAt(int row, int column)` Returns the cell value at row and column.
`protected void` | `initializeLocalVars()` Initializes table properties to their default values.
`boolean` | `isCellEditable(int row, int column)` Returns true if the cell at row and column is editable.
`boolean` | `isCellSelected(int row, int column)` Returns true if the cell at the specified position is selected.
`boolean` | `isColumnSelected(int column)` Returns true if the column at the specified index is selected
`boolean` | `isEditing()` Returns true is the table is editing a cell.
`boolean` | `isManagingFocus()` We override this method, whose implementation in JComponent returns false, to return true.
`boolean` | `isRowSelected(int row)` Returns true if the row at the specified index is selected
`void` | `moveColumn(int column, int targetColumn)` Moves the column column to the position currently occupied by the column targetColumn.
`protected java.lang.String` | `paramString()` Returns a string representation of this JTable.
`java.awt.Component` | `prepareEditor(TableCellEditor editor, int row, int column)` Prepares the specified editor using the value at the specified cell.
`java.awt.Component` | `prepareRenderer(TableCellRenderer renderer, int row, int column)` Prepares the specified renderer with an appropriate value from the dataModel, and an appropriate selection value from the selection models.
`void` | `removeColumn(TableColumn aColumn)` Removes aColumn from the JTable's array of columns.
`void` | `removeColumnSelectionInterval(int index0, int index1)` Deselects the columns from index0 to index0 inclusive.
`void` | `removeEditor()` Discard the editor object and return the real estate it used to cell rendering.
`void` | `removeRowSelectionInterval(int index0, int index1)` Deselects the rows from index0 to index0 inclusive.
`void` | `reshape(int x, int y, int width, int height)` Calls super.reshape(), and is overridden simply to detect changes in our bounds.
`protected void` | `resizeAndRepaint()` Equivalent to revalidate() followed by repaint().
`int` | `rowAtPoint(java.awt.Point point)` Returns the index of the row that point lies in, or -1 if is not in the range [0, getRowCount()-1].
`void` | `selectAll()` Select all rows, columns and cells in the table.
`void` | `setAutoCreateColumnsFromModel(boolean createColumns)` Sets the table's autoCreateColumnsFromModel flag.
`void` | `setAutoResizeMode(int mode)` Sets the table's auto resize mode when the table is resized.
`void` | `setCellEditor(TableCellEditor anEditor)` Set the cellEditor variable.
`void` | `setCellSelectionEnabled(boolean flag)` Sets whether this table allows both a column selection and a row selection to exist at the same time.
`void` | `setColumnModel(TableColumnModel newModel)` Sets the column model for this table to newModel and registers with for listner notifications from the new column model.
`void` | `setColumnSelectionAllowed(boolean flag)` Sets whether the columns in this model can be selected.
`void` | `setColumnSelectionInterval(int index0, int index1)` Selects the columns from index0 to index1 inclusive.
`void` | `setDefaultEditor(java.lang.Class columnClass, TableCellEditor editor)` Set a default editor to be used if no editor has been set in a TableColumn.
`void` | `setDefaultRenderer(java.lang.Class columnClass, TableCellRenderer renderer)` Set a default renderer to be used if no renderer has been set in a TableColumn.
`void` | `setEditingColumn(int aColumn)` Set the editingColumn variable.
`void` | `setEditingRow(int aRow)` Set the editingRow variable.
`void` | `setGridColor(java.awt.Color newColor)` Sets the color used to draw grid lines to color and redisplays the receiver.
`void` | `setIntercellSpacing(java.awt.Dimension newSpacing)` Sets the width and height between cells to newSpacing and redisplays the receiver.
`void` | `setModel(TableModel newModel)` Sets the data model for this table to newModel and registers with for listner notifications from the new data model.
`void` | `setPreferredScrollableViewportSize(java.awt.Dimension size)` Sets the preferred size of the viewport for this table.
`void` | `setRowHeight(int newHeight)` Sets the height for rows to newRowHeight and invokes tile
`void` | `setRowMargin(int rowMargin)` Sets the amount of emtpy space between rows.
`void` | `setRowSelectionAllowed(boolean flag)` Sets whether the rows in this model can be selected.
`void` | `setRowSelectionInterval(int index0, int index1)` Selects the rows from index0 to index1 inclusive.
`void` | `setSelectionBackground(java.awt.Color selectionBackground)` Set the background color for selected cells.
`void` | `setSelectionForeground(java.awt.Color selectionForeground)` Set the foreground color for selected cells.
`void` | `setSelectionMode(int selectionMode)` Sets the table's selection mode to allow only single selections, a single contiguous interval, or multiple intervals.
`void` | `setSelectionModel(ListSelectionModel newModel)` Sets the row selection model for this table to newModel and registers with for listner notifications from the new selection model.
`void` | `setShowGrid(boolean b)` Sets whether the receiver draws grid lines around cells.
`void` | `setShowHorizontalLines(boolean b)` Sets whether the receiver draws horizontal lines between cells.
`void` | `setShowVerticalLines(boolean b)` Sets whether the receiver draws vertical lines between cells.
`void` | `setTableHeader(JTableHeader newHeader)` Sets the tableHeader working with this JTable to newHeader.
`void` | `setUI(TableUI ui)` Sets the L&F object that renders this component.
`void` | `setValueAt(java.lang.Object aValue, int row, int column)` Sets the value for the cell at row and column.
`void` | `sizeColumnsToFit(boolean lastColumnOnly)` Deprecated. As of Swing version 1.0.3, replaced by `sizeColumnsToFit(int)`.
`void` | `sizeColumnsToFit(int resizingColumn)` This method will resize one or more ot the columns in the table so that the total width of all of the JTable's columns will be equal to the width of the table.
`void` | `tableChanged(TableModelEvent e)` The TableModelEvent should be constructed in the co-ordinate system of the model, the appropriate mapping to the view co-ordinate system is performed by the JTable when it recieves the event.
`void` | `updateUI()` Notification from the UIManager that the L&F has changed.
`void` | `valueChanged(ListSelectionEvent e)` Invoked when the selection changes -- repaints to show the new selection.

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInsets, getInsets, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getTopLevelAncestor, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, isDoubleBuffered, isFocusCycleRoot, isFocusTraversable, isLightweightComponent, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, processComponentKeyEvent, processFocusEvent, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, revalidate, scrollRectToVisible, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setEnabled, setFont, setForeground, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, countComponents, deliverEvent, doLayout, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setLayout, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, createImage, createImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, getBackground, getBounds, getColorModel, getCursor, getFont, getFontMetrics, getForeground, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hide, imageUpdate, inside, isEnabled, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processMouseEvent, remove, removeComponentListener, removeFocusListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### AUTO_RESIZE_OFF

    public static final int AUTO_RESIZE_OFF

  Do not adjust column widths automatically, use a scrollbar

### AUTO_RESIZE_NEXT_COLUMN

    public static final int AUTO_RESIZE_NEXT_COLUMN

  When a column is adjusted in the UI, adjust the next column the opposite way

### AUTO_RESIZE_SUBSEQUENT_COLUMNS

    public static final int AUTO_RESIZE_SUBSEQUENT_COLUMNS

  During UI adjustment, change subsequent columns to preserve the total width

### AUTO_RESIZE_LAST_COLUMN

    public static final int AUTO_RESIZE_LAST_COLUMN

  During all resize operations, apply adjustments to the last column only

### AUTO_RESIZE_ALL_COLUMNS

    public static final int AUTO_RESIZE_ALL_COLUMNS

  During all resize operations, proportionately resize all columns

### dataModel

    protected TableModel dataModel

  The TableModel of the table

### columnModel

    protected TableColumnModel columnModel

  The TableColumnModel of the table

### selectionModel

    protected ListSelectionModel selectionModel

  The ListSelectionModel of the table, used to keep track of row selections

### tableHeader

    protected JTableHeader tableHeader

  The TableHeader working with the table

### rowHeight

    protected int rowHeight

  The height of all rows in the table

### rowMargin

    protected int rowMargin

  The height margin between rows

### gridColor

    protected java.awt.Color gridColor

  The color of the grid

### showHorizontalLines

    protected boolean showHorizontalLines

  The table draws horizontal lines between cells if showHorizontalLines is true

### showVerticalLines

    protected boolean showVerticalLines

  The table draws vertical lines between cells if showVerticalLines is true

### autoResizeMode

    protected int autoResizeMode

  This mode value determines if table automatically resizes the width the table's columns to take up the entire width of the table, and how it does the resizing.

### autoCreateColumnsFromModel

    protected boolean autoCreateColumnsFromModel

  The table will query the TableModel to build the default set of columns if this is true.

### preferredViewportSize

    protected java.awt.Dimension preferredViewportSize

  Used by the Scrollable interface to determine the initial visible area

### rowSelectionAllowed

    protected boolean rowSelectionAllowed

  Row selection allowed in this table

### cellSelectionEnabled

    protected boolean cellSelectionEnabled

  If this is true, then both a row selection and a column selection can be non-empty at the same time, the selected cells are the the cells whose row and column are both selected.

### editorComp

    protected transient java.awt.Component editorComp

  If editing, Component that is handling the editing.

### cellEditor

    protected transient TableCellEditor cellEditor

  The object that overwrites the screen real estate occupied by the current cell and allows the user to change those contents.

### editingColumn

    protected transient int editingColumn

  Identifies the column of the cell being edited.

### editingRow

    protected transient int editingRow

  Identifies the row of the cell being edited.

### defaultRenderersByColumnClass

    protected transient java.util.Hashtable defaultRenderersByColumnClass

  A table of objects that display the contents of a cell, indexed by class.

### defaultEditorsByColumnClass

    protected transient java.util.Hashtable defaultEditorsByColumnClass

  A table of objects that display and edit the contents of a cell, indexed by class.

### selectionForeground

    protected java.awt.Color selectionForeground

  The foreground color of selected cells

### selectionBackground

    protected java.awt.Color selectionBackground

  The background color of selected cells

Constructor Detail

### JTable

    public JTable()

  Constructs a default JTable which is initialized with a default data model, a default column model, and a default selection model.
  See Also:
    `createDefaultDataModel()`, `createDefaultColumnModel()`, `createDefaultSelectionModel()`

### JTable

    public JTable(TableModel dm)

  Constructs a JTable which is initialized with dm as the data model, a default column model, and a default selection model.
  Parameters:
    `dm` - The data model for the table
  See Also:
    `createDefaultColumnModel()`, `createDefaultSelectionModel()`

### JTable

    public JTable(TableModel dm,
                  TableColumnModel cm)

  Constructs a JTable which is initialized with dm as the data model, cm as the column model, and a default selection model.
  Parameters:
    `dm` - The data model for the table
    `cm` - The column model for the table
  See Also:
    `createDefaultSelectionModel()`

### JTable

    public JTable(TableModel dm,
                  TableColumnModel cm,
                  ListSelectionModel sm)

  Constructs a JTable which is initialized with dm as the data model, cm as the column model, and sm as the selection model. If any of the parameters are null this method will initialize the table with the corresponding default model. The autoCreateColumnsFromModel flag is set to false if cm is non-null, otherwise it is set to true and the column model is populated with suitable TableColumns for the columns in dm.
  Parameters:
    `dm` - The data model for the table
    `cm` - The column model for the table
    `sm` - The row selection model for the table
  See Also:
    `createDefaultDataModel()`, `createDefaultColumnModel()`, `createDefaultSelectionModel()`

### JTable

    public JTable(int numRows,
                  int numColumns)

  Constructs a JTable with numRows and numColumns of empty cells using the DefaultTableModel. The columns will have names of the form "A", "B", "C", etc.
  Parameters:
    `numRows` - The number of rows the table holds
    `numColumns` - The number of columns the table holds
  See Also:
    `DefaultTableModel`

### JTable

    public JTable(java.util.Vector rowData,
                  java.util.Vector columnNames)

  Constructs a JTable to display the values in the Vector of Vectors, rowData, with column names, columnNames. The Vectors contained in rowData should contain the values for that row. In other words, the value of the cell at row 1, column 5 can be obtained with the following code:

      ((Vector)rowData.elementAt(1)).elementAt(5);

  All rows must be of the same length as columnNames.

  Parameters:
    `rowData` - The data for the new table
    `columnNames` - Names of each column

### JTable

    public JTable(java.lang.Object[][] rowData,
                  java.lang.Object[] columnNames)

  Constructs a JTable to display the values in the two dimensional array, rowData, with column names, columnNames. rowData is an Array of rows, so the value of the cell at row 1, column 5 can be obtained with the following code:

       rowData[1][5];

  All rows must be of the same length as columnNames.

  Parameters:
    `rowData` - The data for the new table
    `columnNames` - Names of each column

Method Detail

### addNotify

    public void addNotify()

  Calls `configureEnclosingScrollPane`.
  Overrides:
    addNotify in class JComponent
  See Also:
    `configureEnclosingScrollPane()`

### configureEnclosingScrollPane

    protected void configureEnclosingScrollPane()

  If the JTable is the viewportView of an enclosing JScrollPane (the usual situation), configure this ScrollPane by, amongst other things, installing the table's tableHeader as the columnHeaderView of the scrollpane. When a JTable is added to a JScrollPane in the usual way, using `new JScrollPane(myTable)`, `addNotify` is called in the JTable (when the table is added to the viewport). JTable's `addNotify` method in turn calls this method which is protected so that this default installation procedure can be overridden by a subclass.
  See Also:
    `addNotify()`

### createScrollPaneForTable

    public static JScrollPane createScrollPaneForTable(JTable aTable)

  Deprecated. As of Swing version 1.0.2, replaced by `new JScrollPane(aTable)`.
  Equivalent to `new JScrollPane(aTable)`.

### setTableHeader

    public void setTableHeader(JTableHeader newHeader)

  Sets the tableHeader working with this JTable to newHeader. It is legal to have a null tableHeader.
  Parameters:
    `newHeader` - new tableHeader
  See Also:
    `getTableHeader()`

### getTableHeader

    public JTableHeader getTableHeader()

  Returns the tableHeader working with this JTable.
  Returns:
    the tableHeader working with the receiver
  See Also:
    `setTableHeader(javax.swing.table.JTableHeader)`

### setRowHeight

    public void setRowHeight(int newHeight)

  Sets the height for rows to newRowHeight and invokes tile
  Parameters:
    `newRowHeight` - new row height
  Throws:
    java.lang.IllegalArgumentException - If newRowHeight is less than 1.
  See Also:
    `getRowHeight()`

### getRowHeight

    public int getRowHeight()

  Returns the height of a table row in the receiver. The default row height is 16.0.
  Returns:
    the height of each row in the receiver
  See Also:
    `setRowHeight(int)`

### setRowMargin

    public void setRowMargin(int rowMargin)

  Sets the amount of emtpy space between rows.
  See Also:
    `getRowMargin()`

### getRowMargin

    public int getRowMargin()

  Gets the amount of emtpy space between rows. Equivalent to: `getIntercellSpacing().height`.
  See Also:
    `setRowMargin(int)`

### setIntercellSpacing

    public void setIntercellSpacing(java.awt.Dimension newSpacing)

  Sets the width and height between cells to newSpacing and redisplays the receiver.
  Parameters:
    `newSpacing` - The new width and height intercellSpacing
  See Also:
    `getIntercellSpacing()`

### getIntercellSpacing

    public java.awt.Dimension getIntercellSpacing()

  Returns the horizontal and vertical spacing between cells. The default spacing is (3, 2).
  Returns:
    the horizontal and vertical spacing between cells
  See Also:
    `setIntercellSpacing(java.awt.Dimension)`

### setGridColor

    public void setGridColor(java.awt.Color newColor)

  Sets the color used to draw grid lines to color and redisplays the receiver. The default color is gray.
  Parameters:
    `color` - new color of the grid
  Throws:
    java.lang.IllegalArgumentException - if color is null
  See Also:
    `getGridColor()`

### getGridColor

    public java.awt.Color getGridColor()

  Returns the color used to draw grid lines. The default color is gray.
  Returns:
    the color used to draw grid lines
  See Also:
    `setGridColor(java.awt.Color)`

### setShowGrid

    public void setShowGrid(boolean b)

  Sets whether the receiver draws grid lines around cells. If flag is true it does; if it is false it doesn't. There is no getShowGrid() method as the this state is held in two variables: showHorizontalLines and showVerticalLines each of which may be queried independently.
  Parameters:
    `flag` - true if table view should draw grid lines
  See Also:
    `setShowVerticalLines(boolean)`, `setShowHorizontalLines(boolean)`

### setShowHorizontalLines

    public void setShowHorizontalLines(boolean b)

  Sets whether the receiver draws horizontal lines between cells. If flag is true it does; if it is false it doesn't.
  Parameters:
    `flag` - true if table view should draw horizontal lines
  See Also:
    `getShowHorizontalLines()`, `setShowGrid(boolean)`, `setShowVerticalLines(boolean)`

### setShowVerticalLines

    public void setShowVerticalLines(boolean b)

  Sets whether the receiver draws vertical lines between cells. If flag is true it does; if it is false it doesn't.
  Parameters:
    `flag` - true if table view should draw vertical lines
  See Also:
    `getShowVerticalLines()`, `setShowGrid(boolean)`, `setShowHorizontalLines(boolean)`

### getShowHorizontalLines

    public boolean getShowHorizontalLines()

  Returns true if the receiver draws horizontal lines between cells, false if it doesn't. The default is true.
  Returns:
    true if the receiver draws horizontal lines between cells, false if it doesn't
  See Also:
    `setShowHorizontalLines(boolean)`

### getShowVerticalLines

    public boolean getShowVerticalLines()

  Returns true if the receiver draws vertical lines between cells, false if it doesn't. The default is true.
  Returns:
    true if the receiver draws vertical lines between cells, false if it doesn't
  See Also:
    `setShowVerticalLines(boolean)`

### setAutoResizeMode

    public void setAutoResizeMode(int mode)

  Sets the table's auto resize mode when the table is resized.
  Parameters:
    `mode` - One of 5 legal values: AUTO_RESIZE_OFF, AUTO_RESIZE_NEXT_COLUMN, AUTO_RESIZE_SUBSEQUENT_COLUMNS, AUTO_RESIZE_LAST_COLUMN, AUTO_RESIZE_ALL_COLUMNS
  See Also:
    `getAutoResizeMode()`, `sizeColumnsToFit(int)`

### getAutoResizeMode

    public int getAutoResizeMode()

  Returns auto resize mode of the table.
  Returns:
    the autoResizeMode of the table
  See Also:
    `setAutoResizeMode(int)`, `sizeColumnsToFit(int)`

### setAutoCreateColumnsFromModel

    public void setAutoCreateColumnsFromModel(boolean createColumns)

  Sets the table's autoCreateColumnsFromModel flag. This method will call createDefaultColumnsFromModel() if createColumns is true.
  Parameters:
    `createColumns` - true if JTable should auto create columns
  See Also:
    `getAutoCreateColumnsFromModel()`, `createDefaultColumnsFromModel()`

### getAutoCreateColumnsFromModel

    public boolean getAutoCreateColumnsFromModel()

  Returns whether the table will create default columns from the model. If this is true, setModel() will clear any existing columns and create new columns from the new model. Also if the event in the the tableChanged() notification specified the entired table changed then the columns will be rebuilt. The default is true.
  Returns:
    the autoCreateColumnsFromModel of the table
  See Also:
    `setAutoCreateColumnsFromModel(boolean)`, `createDefaultColumnsFromModel()`

### createDefaultColumnsFromModel

    public void createDefaultColumnsFromModel()

  This method will create default columns for the table from the data model using the getColumnCount() and getColumnClass() methods defined in the TableModel interface.

  This method will clear any exsiting columns before creating the new columns based on information from the model.

  See Also:
    `getAutoCreateColumnsFromModel()`

### setDefaultRenderer

    public void setDefaultRenderer(java.lang.Class columnClass,
                                   TableCellRenderer renderer)

  Set a default renderer to be used if no renderer has been set in a TableColumn. If renderer is null, remove the default renderer for this column class.
  See Also:
    `getDefaultRenderer(java.lang.Class)`, `setDefaultEditor(java.lang.Class, javax.swing.table.TableCellEditor)`

### getDefaultRenderer

    public TableCellRenderer getDefaultRenderer(java.lang.Class columnClass)

  Returns the renderer to be used when no renderer has been set in a TableColumn. During the rendering of cells the renderer is fetched from a Hashtable of entries according to the class of the cells in the column. If there is no entry for this columnClass the method returns the entry for the most specific superclass. The JTable installs entries for Object, Number and Boolean all which can be modified or replaced.
  See Also:
    `setDefaultRenderer(java.lang.Class, javax.swing.table.TableCellRenderer)`, `getColumnClass(int)`

### setDefaultEditor

    public void setDefaultEditor(java.lang.Class columnClass,
                                 TableCellEditor editor)

  Set a default editor to be used if no editor has been set in a TableColumn. If no editing is required in a table, or a particular column in a table, use the isCellEditable() method in the TableModel interface to ensure that the JTable will not start an editor in these columns. If editor is null, remove the default editor for this column class.
  See Also:
    `TableModel.isCellEditable(int, int)`, `getDefaultEditor(java.lang.Class)`, `setDefaultRenderer(java.lang.Class, javax.swing.table.TableCellRenderer)`

### getDefaultEditor

    public TableCellEditor getDefaultEditor(java.lang.Class columnClass)

  Returns the editor to be used when no editor has been set in a TableColumn. During the editing of cells the editor is fetched from a Hashtable of entries according to the class of the cells in the column. If there is no entry for this columnClass the method returns the entry for the most specific superclass. The JTable installs entries for Object, Number and Boolean all which can be modified or replaced.
  See Also:
    `setDefaultEditor(java.lang.Class, javax.swing.table.TableCellEditor)`, `getColumnClass(int)`

### setSelectionMode

    public void setSelectionMode(int selectionMode)

  Sets the table's selection mode to allow only single selections, a single contiguous interval, or multiple intervals. NOTE:
  JTable provides all the methods for handling column and row selection. When setting states, such as setSelectionMode, it not only updates the mode for the row selection model but also sets similar values in the selection model of the columnModel. If you want to have the row and column selection models operating in different modes, set them both directly.

  Both the row and column selection models for the JTable default to using a DefaultListSelectionModel so that JTable works the same way as the JList. See setSelectionMode() in JList for details about the modes.

  See Also:
    `JList.setSelectionMode(int)`

### setRowSelectionAllowed

    public void setRowSelectionAllowed(boolean flag)

  Sets whether the rows in this model can be selected.
  See Also:
    `getRowSelectionAllowed()`

### getRowSelectionAllowed

    public boolean getRowSelectionAllowed()

  Returns true if rows can be selected.
  Returns:
    true if rows can be selected
  See Also:
    `setRowSelectionAllowed(boolean)`

### setColumnSelectionAllowed

    public void setColumnSelectionAllowed(boolean flag)

  Sets whether the columns in this model can be selected.
  See Also:
    `getColumnSelectionAllowed()`

### getColumnSelectionAllowed

    public boolean getColumnSelectionAllowed()

  Returns true if columns can be selected.
  Returns:
    true if columns can be selected.
  See Also:
    `setColumnSelectionAllowed(boolean)`

### setCellSelectionEnabled

    public void setCellSelectionEnabled(boolean flag)

  Sets whether this table allows both a column selection and a row selection to exist at the same time. When set, this results in a facility to select a rectangular region of cells in the display. This flag over-rides the row and column selection modes ensuring that cell selection is possible whenever this flag is set.
  See Also:
    `getCellSelectionEnabled()`

### getCellSelectionEnabled

    public boolean getCellSelectionEnabled()

  Returns true if simultaneous row and column selections are allowed
  Returns:
    true if simultaneous row and column selections are allowed
  See Also:
    `setCellSelectionEnabled(boolean)`

### selectAll

    public void selectAll()

  Select all rows, columns and cells in the table.

### clearSelection

    public void clearSelection()

  Deselects all selected columns and rows.

### setRowSelectionInterval

    public void setRowSelectionInterval(int index0,
                                        int index1)

  Selects the rows from index0 to index1 inclusive.
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval

### setColumnSelectionInterval

    public void setColumnSelectionInterval(int index0,
                                           int index1)

  Selects the columns from index0 to index1 inclusive.
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval

### addRowSelectionInterval

    public void addRowSelectionInterval(int index0,
                                        int index1)

  Adds the rows from index0 to index0 inclusive to the current selection.
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval

### addColumnSelectionInterval

    public void addColumnSelectionInterval(int index0,
                                           int index1)

  Adds the columns from index0 to index0 inclusive to the current selection.
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval

### removeRowSelectionInterval

    public void removeRowSelectionInterval(int index0,
                                           int index1)

  Deselects the rows from index0 to index0 inclusive.
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval

### removeColumnSelectionInterval

    public void removeColumnSelectionInterval(int index0,
                                              int index1)

  Deselects the columns from index0 to index0 inclusive.
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval

### getSelectedRow

    public int getSelectedRow()

  Returns the index of the last row selected or added to the selection.
  Returns:
    the index of the last row selected or added to the selection, (lead selection) or -1 if no row is selected.
  See Also:
    `getSelectedRows()`

### getSelectedColumn

    public int getSelectedColumn()

  Returns the index of the last column selected or added to the selection.
  Returns:
    the index of the last column selected or added to the selection, (lead selection) or -1 if no column is selected.
  See Also:
    `getSelectedColumns()`

### getSelectedRows

    public int[] getSelectedRows()

  Returns the indices of all selected rows.
  Returns:
    an array of ints containing the indices of all selected rows, or an empty array if no row is selected.
  See Also:
    `getSelectedRow()`

### getSelectedColumns

    public int[] getSelectedColumns()

  Returns the indices of all selected columns.
  Returns:
    an array of ints containing the indices of all selected columns, or an empty array if no column is selected.
  See Also:
    `getSelectedColumn()`

### getSelectedRowCount

    public int getSelectedRowCount()

  Returns the number of selected rows.
  Returns:
    the number of selected rows, 0 if no columns are selected

### getSelectedColumnCount

    public int getSelectedColumnCount()

  Returns the number of selected columns.
  Returns:
    the number of selected columns, 0 if no columns are selected

### isRowSelected

    public boolean isRowSelected(int row)

  Returns true if the row at the specified index is selected
  Returns:
    true if the row at index row is selected, where 0 is the first row
  Throws:
    java.lang.IllegalArgumentException - if row is not in the valid range

### isColumnSelected

    public boolean isColumnSelected(int column)

  Returns true if the column at the specified index is selected
  Returns:
    true if the column at index column is selected, where 0 is the first column
  Throws:
    java.lang.IllegalArgumentException - if column is not in the valid range

### isCellSelected

    public boolean isCellSelected(int row,
                                  int column)

  Returns true if the cell at the specified position is selected.
  Returns:
    true if the cell at index (row, column) is selected, where the first row and first column are at index 0
  Throws:
    java.lang.IllegalArgumentException - if row or column are not in the valid range

### getSelectionForeground

    public java.awt.Color getSelectionForeground()

  Returns the foreground color for selected cells.
  Returns:
    the Color object for the foreground property
  See Also:
    `setSelectionForeground(java.awt.Color)`, `setSelectionBackground(java.awt.Color)`

### setSelectionForeground

    public void setSelectionForeground(java.awt.Color selectionForeground)

  Set the foreground color for selected cells. Cell renderers can use this color to render text and graphics for selected cells.

  The default value of this property is defined by the look and feel implementation.

  This is a JavaBeans bound property.

  Parameters:
    `selectionForeground` - the Color to use in the foreground for selected list items
  See Also:
    `getSelectionForeground()`, `setSelectionBackground(java.awt.Color)`, `JComponent.setForeground(java.awt.Color)`, `JComponent.setBackground(java.awt.Color)`, `JComponent.setFont(java.awt.Font)`

### getSelectionBackground

    public java.awt.Color getSelectionBackground()

  Returns the background color for selected cells.
  Returns:
    the Color used for the background of selected list items
  See Also:
    `setSelectionBackground(java.awt.Color)`, `setSelectionForeground(java.awt.Color)`

### setSelectionBackground

    public void setSelectionBackground(java.awt.Color selectionBackground)

  Set the background color for selected cells. Cell renderers can use this color to the fill selected cells.

  The default value of this property is defined by the look and feel implementation.

  This is a JavaBeans bound property.

  Parameters:
    `selectionBackground` - the Color to use for the background of selected cells
  See Also:
    `getSelectionBackground()`, `setSelectionForeground(java.awt.Color)`, `JComponent.setForeground(java.awt.Color)`, `JComponent.setBackground(java.awt.Color)`, `JComponent.setFont(java.awt.Font)`

### getColumn

    public TableColumn getColumn(java.lang.Object identifier)

  Returns the TableColumn object for the column in the table whose identifier is equal to identifier, when compared using equals().
  Parameters:
    `identifier` - the identifier object
  Returns:
    the TableColumn object with matching identifier
  Throws:
    java.lang.IllegalArgumentException - if identifier is null or no TableColumn has this identifier

### convertColumnIndexToModel

    public int convertColumnIndexToModel(int viewColumnIndex)

  Return the index of the column in the model whose data is being displayed in the column viewColumnIndex in the display. Returns viewColumnIndex unchanged when viewColumnIndex is less than zero.
  See Also:
    `convertColumnIndexToView(int)`

### convertColumnIndexToView

    public int convertColumnIndexToView(int modelColumnIndex)

  Return the index of the column in the view which is displaying the data from the column modelColumnIndex in the model. Returns -1 if this column is not being displayed. Returns modelColumnIndex unchanged when modelColumnIndex is less than zero.
  See Also:
    `convertColumnIndexToModel(int)`

### getRowCount

    public int getRowCount()

  Returns the number of rows in the table.
  See Also:
    `getColumnCount()`

### getColumnCount

    public int getColumnCount()

  Returns the number of columns in the column model, note this may be different to the number of columns in the table model.
  Returns:
    the number of columns in the table
  See Also:
    `getRowCount()`

### getColumnName

    public java.lang.String getColumnName(int column)

  Returns the name of the column at the specified view position.
  Returns:
    the name of the column at position column in the view where the first column is column 0.

### getColumnClass

    public java.lang.Class getColumnClass(int column)

  Returns the type of the column at the specified view position.
  Returns:
    the type of the column at position column in the view where the first column is column 0.

### getValueAt

    public java.lang.Object getValueAt(int row,
                                       int column)

  Returns the cell value at row and column.

  NOTE: The column is specified in the table view's display order, and not in the TableModel's column order. This is an important distinction because as the user rearranges the columns in the table, what is at column 2 changes. Meanwhile the user's actions never affect the model's column ordering.

  Parameters:
    `row` - the row whose value is to be looked up
    `column` - the column whose value is to be looked up
  Returns:
    the Object at the specified cell

### setValueAt

    public void setValueAt(java.lang.Object aValue,
                           int row,
                           int column)

  Sets the value for the cell at row and column. aValue is the new value.
  Parameters:
    `aValue` - the new value
    `row` - the row whose value is to be changed
    `column` - the column whose value is to be changed
  See Also:
    `getValueAt(int, int)`

### isCellEditable

    public boolean isCellEditable(int row,
                                  int column)

  Returns true if the cell at row and column is editable. Otherwise, setValueAt() on the cell will not change the value of that cell.
  Parameters:
    `row` - the row whose value is to be looked up
    `column` - the column whose value is to be looked up
  Returns:
    true if the cell is editable.
  See Also:
    `setValueAt(java.lang.Object, int, int)`

### addColumn

    public void addColumn(TableColumn aColumn)

  Appends aColumn to the end of the array of columns held by the JTable's column model. If the header value of aColumn is null, sets the header value of aColumn to the name returned by `getModel().getColumnName()`.

  To add a column to the JTable to display the modelColumn'th column of data in the model, with a given width, cellRenderer and cellEditor you can use:

            addColumn(new TableColumn(modelColumn, width, cellRenderer, cellEditor));

  [All of the other constructors in the TableColumn can be used in place of this one.] The model column is stored inside the TableColumn and is used during rendering and editing to locate the appropriate data values in the model. The model column does not change when columns are reordered in the view.
  Parameters:
    `aColumn` - The TableColumn to be added
  See Also:
    `removeColumn(javax.swing.table.TableColumn)`

### removeColumn

    public void removeColumn(TableColumn aColumn)

  Removes aColumn from the JTable's array of columns. Note: this method does not remove the column of data from the model it just removes the TableColumn that was displaying it.
  Parameters:
    `aColumn` - The TableColumn to be removed
  See Also:
    `addColumn(javax.swing.table.TableColumn)`

### moveColumn

    public void moveColumn(int column,
                           int targetColumn)

  Moves the column column to the position currently occupied by the column targetColumn. The old column at targetColumn is shifted left or right to make room.
  Parameters:
    `column` - the index of column to be moved
    `targetColumn` - the new index of the column

### columnAtPoint

    public int columnAtPoint(java.awt.Point point)

  Returns the index of the column that point lies in, or -1 if it lies outside the receiver's bounds.
  Returns:
    the index of the column that point lies in, or -1 if it lies outside the receiver's bounds
  See Also:
    `rowAtPoint(java.awt.Point)`

### rowAtPoint

    public int rowAtPoint(java.awt.Point point)

  Returns the index of the row that point lies in, or -1 if is not in the range [0, getRowCount()-1].
  Returns:
    the index of the row that point lies in, or -1 if it is not in the range [0, getRowCount()-1]
  See Also:
    `columnAtPoint(java.awt.Point)`

### getCellRect

    public java.awt.Rectangle getCellRect(int row,
                                          int column,
                                          boolean includeSpacing)

  Returns a rectangle locating the cell that lies at the intersection of row and column. If includeSpacing is true then the value returned includes the intercellSpacing margin. If it is false, then the returned rect is inset by half of intercellSpacing. (This is the true frame of the cell)
  Parameters:
    `row` - the row to compute
    `column` - the column to compute
    `includeSpacing` - if true, the rect returned will include the correct intercellSpacing
  Returns:
    the rectangle containing the cell at index row,column
  Throws:
    java.lang.IllegalArgumentException - If row or column are not in the valid range.

### reshape

    public void reshape(int x,
                        int y,
                        int width,
                        int height)

  Calls super.reshape(), and is overridden simply to detect changes in our bounds. After reshaping we resize the columns (similar to triggering a layout) to fit the new bounds for the component using sizeColumnsToFit().
  Overrides:
    reshape in class JComponent
  See Also:
    `sizeColumnsToFit(int)`

### sizeColumnsToFit

    public void sizeColumnsToFit(boolean lastColumnOnly)

  Deprecated. As of Swing version 1.0.3, replaced by `sizeColumnsToFit(int)`.
  Sizes the table columns to fit the available space.
  See Also:
    `sizeColumnsToFit(int)`

### sizeColumnsToFit

    public void sizeColumnsToFit(int resizingColumn)

  This method will resize one or more ot the columns in the table so that the total width of all of the JTable's columns will be equal to the width of the table.

  When setBounds() is called on the JTable, often as a result of resizing of an enclosing window - this method is called with `resizingColumn` set to -1. This means that resizing has taken place 'outside' the JTable and the change - or 'delta' - should be distributed to all of the columns regardless of the JTable's autoResizeMode mode.

  If the `resizingColumn` is not -1, it is one of the columns in the table that has changed size rather than the table itself. In this case the auto-resize modes govern the way the extra (or defecit) space is distributed amongst the availible columns.

  The modes are:

  - AUTO_RESIZE_OFF Don't automatically adjust the column's widths at all. Use a horizontal scrollbar to accomodate the columns when their sum exceeds the width of the Viewport. If the JTable is not enclosed in a JScrollPane this may leave parts of the table invisible.
  - AUTO_RESIZE_NEXT_COLUMN: Use just the column after the resizing column. This results in the 'boundry' or divider between adjacent cells being independently adjustable.
  - AUTO_RESIZE_SUBSEQUENT_COLUMNS: Use all columns after the one being adjusted to absorb the changes.
  - AUTO_RESIZE_LAST_COLUMN Only ever automatically adjust the size of the last column. If the bounds of the last column prevent the desired size from being allocated, set the width of the last column to the appropriate limit and make no further adjustments.
  - AUTO_RESIZE_ALL_COLUMNS Spread the delta amongst all the columns in the JTable, including the one that is being adjusted.

  Note: When the JTable makes adjustments to the widths of the columns it respects their minimum and maximum values absolutely. It is therefore possible that, even after this method is called, the total width of the columns is still not equal to the width of the table. When this happens the JTable does not put itself in AUTO_RESIZE_OFF mode to bring up a ScrollBar, or break other commitments of its current auto-resize mode - instead it allows its bounds to be set larger (or smaller) than the total of the column minima or maxima, meaning, either that there will not be enough room to display all of the columns, or that the columns will not fill the JTable's bounds. These respectively, result in the clipping of some columns or an area being painted in the JTable's background color during painting.

  The mechanism for distributing the delta amongst the availible columns is provided in a private method in the JTable class:

         adjustSizes(long targetSize, final Resizable3 r, boolean inverse)

  an explanation of which is provided below. Resizable3 is a private interface that allows any data structure containing a collection of elements with a size, preferredSize, maximumSize and minimumSize to have its elements manipulated by the algorithm.

  ### Distributing the delta

  #### Overview

  Call 'DELTA' the difference between the targetSize and the sum of the preferred sizes of the elements in r. The individual sizes are calculated by taking the original preferred sizes and adding a share of the DELTA - that share being based on how far each preferred size is from its limiting bound (minimum or maximum).

  #### Definition

  Call the individual constraints min[i], max[i] and pref[i].

  Call their respective sums: MIN, MAX and PREF.

  Each new size will be calculated using:

                size[i] = pref[i] + delta[i]

  where each individual delta[i] is calculated according to:

  If (DELTA < 0) we are in shrink mode where:

                                 DELTA
               delta[i] =     ------------ * (pref[i] - min[i])
                              (PREF - MIN)

  If (DELTA > 0) we are in expand mode where:

                                 DELTA
               delta[i] =     ------------ * (max[i] - pref[i])
                              (MAX - PREF)

  The overall effect is that the total size moves that same percentage, k, towards the total minimum or maximum and that percentage guarentees accomodation of the required space, DELTA.

  #### Details

  Naive evaluation of the formulae presented here would be subject to the aggregated rounding errors caused by doing this operation in finite precision (using ints). To deal with this, the muliplying factor above, is constantly recalculated and this takes account of the rounding errors in the previous iterations. The result is an algorithm which produces a set of integers whose values exactly sum to the supplied `targetSize`, and does so by spreading the rounding errors evenly over the given elements.

  #### When the MAX and MIN bounds are hit

  When `targetSize` is outside the [MIN, MAX] range, the algorithm sets all sizes to either their appropriate limiting value (maximum or minimum).

  Parameters:
    `resizingColumn` - The column whose resizing made this adjustment necessary or -1 if there is no such column.
  See Also:
    `TableColumn.setWidth(int)`

### getToolTipText

    public java.lang.String getToolTipText(java.awt.event.MouseEvent event)

  Overrides JComponent's setToolTipText method to allow use of the renderer's tips (if the renderer has text set).

  NOTE: For JTable to properly display tooltips of its renderers JTable must be a registered component with the ToolTipManager. This is done automatically in initializeLocalVars(), but if at a later point JTable is told setToolTipText(null) it will unregister the table component, and no tips from renderers will display anymore.

  Overrides:
    getToolTipText in class JComponent
  See Also:
    `JComponent.getToolTipText()`

### editCellAt

    public boolean editCellAt(int row,
                              int column)

  Programmatically starts editing the cell at row and column, if the cell is editable.
  Parameters:
    `row` - the row to be edited
    `column` - the column to be edited
  Returns:
    false if for any reason the cell cannot be edited.
  Throws:
    java.lang.IllegalArgumentException - If row or column are not in the valid range

### editCellAt

    public boolean editCellAt(int row,
                              int column,
                              java.util.EventObject e)

  Programmatically starts editing the cell at row and column, if the cell is editable. To prevent the JTable from editing a particular table, column or cell value, return false from the isCellEditable() method in the TableModel interface.
  Parameters:
    `row` - the row to be edited
    `column` - the column to be edited
    `e` - event to pass into shouldSelectCell
  Returns:
    false if for any reason the cell cannot be edited.
  Throws:
    java.lang.IllegalArgumentException - If row or column are not in the valid range

### isEditing

    public boolean isEditing()

  Returns true is the table is editing a cell.
  Returns:
    true is the table is editing a cell
  See Also:
    `editingColumn`, `editingRow`

### getEditorComponent

    public java.awt.Component getEditorComponent()

  If the receiver is currently editing this will return the Component that was returned from the CellEditor.
  Returns:
    Component handling editing session

### getEditingColumn

    public int getEditingColumn()

  This returns the index of the editing column.
  Returns:
    the index of the column being edited
  See Also:
    `editingRow`

### getEditingRow

    public int getEditingRow()

  Returns the index of the editing row.
  Returns:
    the index of the row being edited
  See Also:
    `editingColumn`

### getUI

    public TableUI getUI()

  Returns the L&F object that renders this component.
  Returns:
    the TableUI object that renders this component

### setUI

    public void setUI(TableUI ui)

  Sets the L&F object that renders this component.
  Parameters:
    `ui` - the TableUI L&F object
  See Also:
    `UIDefaults.getUI(javax.swing.JComponent)`

### updateUI

    public void updateUI()

  Notification from the UIManager that the L&F has changed. Replaces the current UI object with the latest version from the UIManager.
  Overrides:
    updateUI in class JComponent
  See Also:
    `JComponent.updateUI()`

### getUIClassID

    public java.lang.String getUIClassID()

  Returns the name of the L&F class that renders this component.
  Returns:
    "TableUI"
  Overrides:
    getUIClassID in class JComponent
  See Also:
    `JComponent.getUIClassID()`, `UIDefaults.getUI(javax.swing.JComponent)`

### setModel

    public void setModel(TableModel newModel)

  Sets the data model for this table to newModel and registers with for listner notifications from the new data model.
  Parameters:
    `newModel` - the new data source for this table
  Throws:
    java.lang.IllegalArgumentException - if newModel is null
  See Also:
    `getModel()`

### getModel

    public TableModel getModel()

  Returns the TableModel that provides the data displayed by the receiver.
  Returns:
    the object that provides the data displayed by the receiver
  See Also:
    `setModel(javax.swing.table.TableModel)`

### setColumnModel

    public void setColumnModel(TableColumnModel newModel)

  Sets the column model for this table to newModel and registers with for listner notifications from the new column model. Also sets the column model of the JTableHeader to newModel.
  Parameters:
    `newModel` - the new data source for this table
  Throws:
    java.lang.IllegalArgumentException - if newModel is null
  See Also:
    `getColumnModel()`

### getColumnModel

    public TableColumnModel getColumnModel()

  Returns the TableColumnModel that contains all column inforamtion of this table.
  Returns:
    the object that provides the column state of the table
  See Also:
    `setColumnModel(javax.swing.table.TableColumnModel)`

### setSelectionModel

    public void setSelectionModel(ListSelectionModel newModel)

  Sets the row selection model for this table to newModel and registers with for listner notifications from the new selection model.
  Parameters:
    `newModel` - the new selection model
  Throws:
    java.lang.IllegalArgumentException - if newModel is null
  See Also:
    `getSelectionModel()`

### getSelectionModel

    public ListSelectionModel getSelectionModel()

  Returns the ListSelectionModel that is used to maintain row selection state.
  Returns:
    the object that provides row selection state. Or null if row selection is not allowed.
  See Also:
    `setSelectionModel(javax.swing.ListSelectionModel)`

### tableChanged

    public void tableChanged(TableModelEvent e)

  The TableModelEvent should be constructed in the co-ordinate system of the model, the appropriate mapping to the view co-ordinate system is performed by the JTable when it recieves the event.
  Specified by:
    tableChanged in interface TableModelListener

### columnAdded

    public void columnAdded(TableColumnModelEvent e)

  Tells listeners that a column was added to the model.
  Specified by:
    columnAdded in interface TableColumnModelListener
  See Also:
    `TableColumnModelListener`

### columnRemoved

    public void columnRemoved(TableColumnModelEvent e)

  Tells listeners that a column was removed from the model.
  Specified by:
    columnRemoved in interface TableColumnModelListener
  See Also:
    `TableColumnModelListener`

### columnMoved

    public void columnMoved(TableColumnModelEvent e)

  Tells listeners that a column was repositioned.
  Specified by:
    columnMoved in interface TableColumnModelListener
  See Also:
    `TableColumnModelListener`

### columnMarginChanged

    public void columnMarginChanged(ChangeEvent e)

  Tells listeners that a column was moved due to a margin change.
  Specified by:
    columnMarginChanged in interface TableColumnModelListener
  See Also:
    `TableColumnModelListener`

### columnSelectionChanged

    public void columnSelectionChanged(ListSelectionEvent e)

  Tells listeners that the selection model of the TableColumnModel changed.
  Specified by:
    columnSelectionChanged in interface TableColumnModelListener
  See Also:
    `TableColumnModelListener`

### valueChanged

    public void valueChanged(ListSelectionEvent e)

  Invoked when the selection changes -- repaints to show the new selection.
  Specified by:
    valueChanged in interface ListSelectionListener
  See Also:
    `ListSelectionListener`

### editingStopped

    public void editingStopped(ChangeEvent e)

  Invoked when editing is finished. The changes are saved, the editor object is discarded, and the cell is rendered once again.
  Specified by:
    editingStopped in interface CellEditorListener
  See Also:
    `CellEditorListener`

### editingCanceled

    public void editingCanceled(ChangeEvent e)

  Invoked when editing is canceled. The editor object is discarded and the cell is rendered once again.
  Specified by:
    editingCanceled in interface CellEditorListener
  See Also:
    `CellEditorListener`

### setPreferredScrollableViewportSize

    public void setPreferredScrollableViewportSize(java.awt.Dimension size)

  Sets the preferred size of the viewport for this table.
  Parameters:
    `size` - a Dimension object specifying the preferredSize of a JViewport whose view is this table
  See Also:
    `Scrollable.getPreferredScrollableViewportSize()`

### getPreferredScrollableViewportSize

    public java.awt.Dimension getPreferredScrollableViewportSize()

  Returns the preferred size of the viewport for this table.
  Specified by:
    getPreferredScrollableViewportSize in interface Scrollable
  Returns:
    a Dimension object containing the preferredSize of the JViewport which displays this table
  See Also:
    `Scrollable.getPreferredScrollableViewportSize()`

### getScrollableUnitIncrement

    public int getScrollableUnitIncrement(java.awt.Rectangle visibleRect,
                                          int orientation,
                                          int direction)

  Returns the scroll increment that completely exposes one new row or column (depending on the orientation).

  This method is called each time the user requests a unit scroll.

  Specified by:
    getScrollableUnitIncrement in interface Scrollable
  Parameters:
    `visibleRect` - The view area visible within the viewport
    `orientation` - Either SwingConstants.VERTICAL or SwingConstants.HORIZONTAL.
    `direction` - Less than zero to scroll up/left, greater than zero for down/right.
  Returns:
    The "unit" increment for scrolling in the specified direction
  See Also:
    `Scrollable.getScrollableUnitIncrement(java.awt.Rectangle, int, int)`

### getScrollableBlockIncrement

    public int getScrollableBlockIncrement(java.awt.Rectangle visibleRect,
                                           int orientation,
                                           int direction)

  Returns The visibleRect.height or visibleRect.width, depending on the table's orientation.
  Specified by:
    getScrollableBlockIncrement in interface Scrollable
  Returns:
    The visibleRect.height or visibleRect.width per the orientation.
  See Also:
    `Scrollable.getScrollableBlockIncrement(java.awt.Rectangle, int, int)`

### getScrollableTracksViewportWidth

    public boolean getScrollableTracksViewportWidth()

  Returns false to indicate that the width of the viewport does not determine the width of the table.
  Specified by:
    getScrollableTracksViewportWidth in interface Scrollable
  Returns:
    false
  See Also:
    `Scrollable.getScrollableTracksViewportWidth()`

### getScrollableTracksViewportHeight

    public boolean getScrollableTracksViewportHeight()

  Returns false to indicate that the height of the viewport does not determine the height of the table.
  Specified by:
    getScrollableTracksViewportHeight in interface Scrollable
  Returns:
    false
  See Also:
    `Scrollable.getScrollableTracksViewportHeight()`

### createDefaultRenderers

    protected void createDefaultRenderers()

### createDefaultEditors

    protected void createDefaultEditors()

  Creates default cell editors for Objects, numbers, and boolean values.

### initializeLocalVars

    protected void initializeLocalVars()

  Initializes table properties to their default values.

### createDefaultDataModel

    protected TableModel createDefaultDataModel()

  Returns the default table model object which is a DefaultTableModel. Subclass can override this method to return a different table model object.
  Returns:
    the default table model object

### createDefaultColumnModel

    protected TableColumnModel createDefaultColumnModel()

  Returns the default column model object which is a DefaultTableColumnModel. Subclass can override this method to return a different column model object
  Returns:
    the default column model object

### createDefaultSelectionModel

    protected ListSelectionModel createDefaultSelectionModel()

  Returns the default selection model object which is a DefaultListSelectionModel. Subclass can override this method to return a different selection model object.
  Returns:
    the default selection model object

### createDefaultTableHeader

    protected JTableHeader createDefaultTableHeader()

  Returns the default table header object which is a JTableHeader. Subclass can override this method to return a different table header object
  Returns:
    the default table header object

### resizeAndRepaint

    protected void resizeAndRepaint()

  Equivalent to revalidate() followed by repaint().

### getCellEditor

    public TableCellEditor getCellEditor()

  Return the cellEditor.
  Returns:
    the TableCellEditor that does the editing
  See Also:
    `cellEditor`

### setCellEditor

    public void setCellEditor(TableCellEditor anEditor)

  Set the cellEditor variable.
  Parameters:
    `anEditor` - the TableCellEditor that does the editing
  See Also:
    `cellEditor`

### setEditingColumn

    public void setEditingColumn(int aColumn)

  Set the editingColumn variable.
  See Also:
    `editingColumn`

### setEditingRow

    public void setEditingRow(int aRow)

  Set the editingRow variable.
  See Also:
    `editingRow`

### getCellRenderer

    public TableCellRenderer getCellRenderer(int row,
                                             int column)

  Return an appropriate renderer for the cell specified by this this row and column. If the TableColumn for this column has a non-null renderer, return that. If not, find the class of the data in this column (using getColumnClass()) and return the default renderer for this type of data.
  Parameters:
    `row` - the row of the cell to render, where 0 is the first
    `column` - the column of the cell to render, where 0 is the first

### prepareRenderer

    public java.awt.Component prepareRenderer(TableCellRenderer renderer,
                                              int row,
                                              int column)

  Prepares the specified renderer with an appropriate value from the dataModel, and an appropriate selection value from the selection models.
  Parameters:
    `renderer` - the TableCellRenderer to prepare
    `row` - the row of the cell to render, where 0 is the first
    `column` - the column of the cell to render, where 0 is the first

### getCellEditor

    public TableCellEditor getCellEditor(int row,
                                         int column)

  Return an appropriate editor for the cell specified by this this row and column. If the TableColumn for this column has a non-null editor, return that. If not, find the class of the data in this column (using getColumnClass()) and return the default editor for this type of data.
  Parameters:
    `row` - the row of the cell to edit, where 0 is the first
    `column` - the column of the cell to edit, where 0 is the first

### prepareEditor

    public java.awt.Component prepareEditor(TableCellEditor editor,
                                            int row,
                                            int column)

  Prepares the specified editor using the value at the specified cell.
  Parameters:
    `editor` - the TableCellEditor to set up
    `row` - the row of the cell to edit, where 0 is the first
    `column` - the column of the cell to edit, where 0 is the first

### removeEditor

    public void removeEditor()

  Discard the editor object and return the real estate it used to cell rendering.

### paramString

    protected java.lang.String paramString()

  Returns a string representation of this JTable. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

  Overriding paramString() to provide information about the specific new aspects of the JFC components.

  Returns:
    a string representation of this JTable.
  Overrides:
    paramString in class JComponent

### isManagingFocus

    public boolean isManagingFocus()

  We override this method, whose implementation in JComponent returns false, to return true. This allows us to give a special meaning to TAB and SHIFT-TAB in the JTable.
  Overrides:
    isManagingFocus in class JComponent

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Get the AccessibleContext associated with this JComponent
  Specified by:
    getAccessibleContext in interface Accessible
  Returns:
    the AccessibleContext of this JComponent
  Overrides:
    getAccessibleContext in class JComponent

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.